package com.zhongzheng.modules.base.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.base.bo.ActivityAdvertisingLocationAddBo;
import com.zhongzheng.modules.base.bo.ActivityAdvertisingLocationEditBo;
import com.zhongzheng.modules.base.bo.ActivityAdvertisingLocationQueryBo;
import com.zhongzheng.modules.base.domain.ActivityAdvertisingLocation;
import com.zhongzheng.modules.base.mapper.ActivityAdvertisingLocationMapper;
import com.zhongzheng.modules.base.service.IActivityAdvertisingLocationService;
import com.zhongzheng.modules.base.vo.ActivityAdvertisingLocationVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 广告位Service业务层处理
 *
 * @author hjl
 * @date 2022-01-13
 */
@Service
public class ActivityAdvertisingLocationServiceImpl extends ServiceImpl<ActivityAdvertisingLocationMapper, ActivityAdvertisingLocation> implements IActivityAdvertisingLocationService {

    @Override
    public ActivityAdvertisingLocationVo queryById(Long locationId){
        ActivityAdvertisingLocation db = this.baseMapper.selectById(locationId);
        return BeanUtil.toBean(db, ActivityAdvertisingLocationVo.class);
    }

    @Override
    public ActivityAdvertisingLocationVo queryByKey(String key) {
        LambdaQueryWrapper<ActivityAdvertisingLocation> lqw = Wrappers.lambdaQuery();
        lqw.eq(ActivityAdvertisingLocation::getLocationKey, key);
        ActivityAdvertisingLocation db = this.baseMapper.selectOne(lqw.last("limit 1"));
        return BeanUtil.toBean(db, ActivityAdvertisingLocationVo.class);
    }

    @Override
    public List<ActivityAdvertisingLocationVo> queryList(ActivityAdvertisingLocationQueryBo bo) {
        LambdaQueryWrapper<ActivityAdvertisingLocation> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getName()), ActivityAdvertisingLocation::getName, bo.getName());
        lqw.eq(bo.getIntervalTime() != null, ActivityAdvertisingLocation::getIntervalTime, bo.getIntervalTime());
        lqw.in(bo.getStatus() != null, ActivityAdvertisingLocation::getStatus, bo.getStatus());
        lqw.eq(StrUtil.isNotBlank(bo.getLocationKey()), ActivityAdvertisingLocation::getLocationKey, bo.getLocationKey());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityAdvertisingLocationVo> entity2Vo(Collection<ActivityAdvertisingLocation> collection) {
        List<ActivityAdvertisingLocationVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityAdvertisingLocationVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityAdvertisingLocation> page = (Page<ActivityAdvertisingLocation>)collection;
            Page<ActivityAdvertisingLocationVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ActivityAdvertisingLocationAddBo bo) {
        ActivityAdvertisingLocation add = BeanUtil.toBean(bo, ActivityAdvertisingLocation.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ActivityAdvertisingLocationEditBo bo) {
        ActivityAdvertisingLocation update = BeanUtil.toBean(bo, ActivityAdvertisingLocation.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityAdvertisingLocation entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
